package application

import (
	"context"
	"github.com/iVampireSP/pkg/random"
	"leafdev.top/Ecosystem/recommender/internal/entity"
)

func (s *Service) ListToken(ctx context.Context, application *entity.Application) ([]*entity.ApplicationToken, error) {
	return s.dao.ApplicationToken.WithContext(ctx).Where(s.dao.ApplicationToken.ApplicationId.Eq(application.Id.Uint())).Find()
}

func (s *Service) CreateToken(ctx context.Context, application *entity.Application) (*entity.ApplicationToken, error) {
	var token = random.String(32)

	var at = &entity.ApplicationToken{
		ApplicationId: application.Id,
		Token:         token,
	}

	err := s.dao.ApplicationToken.WithContext(ctx).Create(at)

	return at, err
}
